



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL事物隔离级别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL事物隔离级别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 19:52:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>标准SQL定义了4个隔离级别</p>
<p><a>Read uncommitted</a>　　未提交读</p>
<p><a>Read committed</a>　　　 已提交读　　</p>
<p><a>Repeatable read</a>　　　 可重复读</p>
<p><a>Serializable</a>　　　　　　可序列化</p>
<p>基本语法</p>
<div>
<pre class="prettyprint linenums">SET TRANSACTION ISOLATION LEVEL<br />
    { READ UNCOMMITTED | READ COMMITTED | REPEATABLE READ | SNAPSHOT | SERIALIZABLE };</pre>
</div>
<h3>1、<strong>READ UNCOMMITTED</strong></h3>
<p>未提交读是最低的事务隔离级别，<strong>允许读取其他事务已经修改但未提交的数据行</strong>。在该隔离级别下，针对数据资源的<strong>读操作将不会申请共享锁，也不影响其他事物对该数据资源请求排他或独占锁</strong>，直接读取数据。在该事物隔离级别下，有可能读取到其他事物中修改但未提交的数据，因此这种读取也被称作<strong>脏读</strong>。</p>
<p>未提交读与<strong>NOLOCK</strong>语句具有相同的效果。</p>
<div>
<pre class="prettyprint linenums">CREATE TABLE Test<br />
(<br />
    Id BIGINT PRIMARY KEY,<br />
    Name NVARCHAR(20) DEFAULT NULL<br />
)</pre>
</div>
<p>往表中新增两条数据</p>
<div>
<pre class="prettyprint linenums">INSERT INTO Test VALUES(0,'陈楚生'),(1,'白百何')</pre>
</div>
<p>在事物A中更新Id为0的数据，但不提交</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
--在事物中修改Test中Id为0的数据，但不提交<br />
UPDATE Test SET Name='范玮琪' WHERE Id=0</pre>
</div>
<p>在事物B中使用未提交读级别查询Id为0的数据</p>
<div>
<pre class="prettyprint linenums">--使用未提交读级别将会读取到其他事物中未提交的修改，产生脏读<br />
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;<br />
BEGIN TRAN<br />
SELECT * FROM Test WHERE Id=0<br />
COMMIT</pre>
</div>
<p>结果可见在事物B中读取到了事物A中未提交的修改。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/565260/201608/565260-20160815003902125-1554119425.png" /></p>
<h3>2、<strong>READ COMMITTED</strong></h3>
<p>已提交读是大部分关系型数据库的默认事物隔离级别，在该级别下，<strong>只能读取到其他事物已提交的修改</strong>。当事务读取数据时，数据库引擎将<strong>放置共享锁</strong>以防止其他事务修改该数据，读取完成则释放共享锁，此时其他事物可以对数据继续进行修改。</p>
<p>假如在一个事物A中，有两个相同的查询语句S1、S2，在已提交读级别下，当执行S1语句时，读操作将会申请共享锁，此时另一个事物B将智能对S1数据资源进行读操作，而不能进行写操作。待事物A中S1语句执行完毕之后，数据资源申请的共享锁被释放，此时假如B事物对S1语句的数据资源进行修改（共享锁已被释放，此时可以被修改），然后事物A继续执行S2，此时虽然S1语句和S2语句一样，但是由于在这两个语句之间，事物B对资源做了修改操作，就有可能导致S1、S2语句得到不一样的结果，这种现象叫<strong>不可重复读</strong></p>
<p>在SQL&nbsp;SERVER&nbsp;2005以上版本中，如果设置<strong>READ_COMMITTED_SNAPSHOT</strong>为ON，则在快照隔离级别下<strong>读操作不需要申请获得共享锁，也不影响其他事物对数据申请排他或独占锁，</strong>而且仍然可以得到和SERIALIZABLE与READ COMMITTED隔离级别类似的一致性；如果目前版本与预期的版本不一致，读操作可以从TEMPDB中获取预期的版本。</p>
<p>在事物A中修改Id为0的数据，但不提交</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
--在事物中修改Test中Id为0的数据，但不提交<br />
UPDATE Test SET Name='范玮琪' WHERE Id=0</pre>
</div>
<p>在事物B中使用已提交读隔离级别读取Id为0的数据</p>
<div>
<pre class="prettyprint linenums">SET TRANSACTION ISOLATION LEVEL READ COMMITTED;<br />
BEGIN TRAN<br />
SELECT * FROM Test WHERE Id=0<br />
COMMIT</pre>
</div>
<p>结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/565260/201608/565260-20160815010709375-1942415194.png" /></p>
<h3>3、<strong>3.REPEATABLE READ</strong></h3>
<p>在可重复读隔离级别下，<strong>对第一次的查询数据资源请求共享锁，并保留到事务结束，</strong>因此在整个事物过程中，重复查询相同记录时，不受其他事物的影响。但由于共享锁知道事务结束才会被释放，因此如果事务持续太久，将有可能影响到其他事物对这些数据的写入操作。<strong>【共享锁】</strong></p>
<p>在可重复读的隔离级别下查询Id为0的数据，但不提交</p>
<div>
<pre class="prettyprint linenums">SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;<br />
BEGIN TRAN<br />
--查询结果为Id为1的数据，针对该数据数据库引擎将会放置共享锁<br />
--因此在其他事物中对Id为0的数据做修改或者新增新数据，都不受影响<br />
SELECT * FROM Test WHERE Id&gt;0</pre>
</div>
<p>在另外一个事物中对Id为1的数据执行更新操作，此时因为Id为1数据上的共享锁跟随所在的事务释放，而事务未提交或回滚，因此该更新操作将不能执行。</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
UPDATE Test SET Name='范玮琪' WHERE Id=1<br />
COMMIT</pre>
</div>
<p>结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/565260/201608/565260-20160815010709375-1942415194.png" /></p>
<h3>4、<strong>SERIALIZABLE</strong></h3>
<p>在可重复读隔离级别下，数据库引擎将会锁定符合查询条件的数据资源，确保这些资源在事务周期内的一致性，但不能锁定查询结果之外的行。例如有两个事务A、B</p>
<p>假如A的事物隔离级别为可重复读，并且在A中有两个相同的查询S1、S2，当执行S1语句时，数据库引擎将会在S1的数据资源上设置共享锁，</p>
<p>因此其他事务中对该部分资源将智能查看而不能修改，此时事务B对资源表进行新增操作，并且新增的数据符合S1和S2的查询条件，然后事务A继续执行S2语句，</p>
<p>此时S2结果将会与S1结果不同，这种现象称之为<strong>幻读</strong>。可序列化隔离级别与HOLDLOCK具有相同效果</p>
<p><strong>在可序列化隔离级别下，将会对整个范围的资源添加区间锁，整个区间范围内的数据都将被锁定，直到事务被提交或回滚。</strong></p>
<p>在可序列化级别下，执行一个查询Id&gt;0的操作，但不提交事务</p>
<div>
<pre class="prettyprint linenums">SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;<br />
BEGIN TRAN<br />
--查询结果为Id大于1的数据，都将被锁定，不能新增，修改，删除。<br />
SELECT * FROM Test WHERE Id&gt;0</pre>
</div>
<p>在另外一个事物中执行新增Id=3的操作</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
INSERT INTO Test VALUES(3,'马天宇')<br />
COMMIT</pre>
</div>
<p>在另外一个事物中执行删除Id=2的操作</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
DELETE FROM Test WHERE Id=2<br />
COMMIT</pre>
</div>
<p>在另外一个事物中执行更新Id=2的操作</p>
<div>
<pre class="prettyprint linenums">BEGIN TRAN<br />
UPDATE Test SET Name='陈楚生' WHERE Id=2<br />
COMMIT</pre>
</div>
<p>结果都是</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/565260/201608/565260-20160815010709375-1942415194.png" /></p>
<p><strong>可见在可序列化隔离级别下满足条件范围的资源都将被锁定</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqve26x9.html">SharePoint 2013 Search REST API 使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2x2mw9.html">iOS开发&mdash;&mdash;高级篇&mdash;&mdash;二维码的生产和读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93djr08.html">完全使用接口方式调用WCF 服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxyple9.html">JS编写全选，复选按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxj5g8.html">mybatis的批量删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9po2gkq.html">JavaScript基础--事件驱动和访问CSS技术&lpar;十&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4dw79.html">CSS &colon;hover伪类选择定义和用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvd2xxq.html">使用fwrite&lpar;&rpar;函数和fprintf&lpar;&rpar;函数输出数据到文件时的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1d4x28.html">C和C&plus;&plus;中结构体&lpar;struct&rpar;、联合体&lpar;union&rpar;、枚举&lpar;enum&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvwpk9.html">编译arm64错误记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12oxv9.html">C&num; 类是怎么执行的？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0z7eq.html">温习PYTHON语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4y7oq.html">hdu 5335 Walk Out&lpar;bfs&plus;寻找路径&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1p62m9.html">Android Layout Binder（在线将XML中View  find出来，生成java代码的工具）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey7dkk9.html">如何为开发项目编写规范的README文件（windows），此文详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxwgxq.html">【HBase】-NO&period;140&period;HBase&period;1 -【HBase】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjy10q.html">IOS-43-导航栏标题navigationItem&period;title不能改变颜色的两种解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4kml9.html">Ext&period;net GridPanel锁定列需要注意的几个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjz0539.html">GDC2017 把&OpenCurlyDoubleQuote;现实的天空&rdquo;在游戏内再现【Forza Horizon 3】的天空表现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw5v0y8.html">新的ipad&comma;用xcode编译报错  dyld&lowbar;shared&lowbar;cache&lowbar;extract&lowbar;dylibs</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdk33j9.html">python画图&mdash;黑板客老师课程学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qygnxgq.html">多线程爬取 threading&period;Thread   文件名支持gbk编码</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdk2109.html">angular&plus;ionic返回上一页并刷新</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z30y1q.html">iOS 9&sol;10强制使用https访问网络，使用了第三方SDK的应用需要配置的信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7vkm8.html">ASP&period;NET5 Beta8可用性</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7vve8.html">错误：E：Unable to locate package &period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4dlxnq.html">启动WCF多个服务方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4dxp3q.html">spring boot 学习笔记&lpar;二&rpar; 构建web支持jsp</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvkxeo9.html">在ubuntu16编译安装nginx-1&period;10&period;2（full）完全自带组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ewpgk8.html">PHP获取页面执行时间的方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
